《操作系统》的实验代码。
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

275 lines
7.1 KiB

10 years ago
10 years ago
10 years ago
10 years ago
10 years ago
10 years ago
  1. PROJ := 8
  2. EMPTY :=
  3. SPACE := $(EMPTY) $(EMPTY)
  4. SLASH := /
  5. V := @
  6. # try to infer the correct GCCPREFX
  7. ifndef GCCPREFIX
  8. GCCPREFIX := $(shell if i386-ucore-elf-objdump -i 2>&1 | grep '^elf32-i386$$' >/dev/null 2>&1; \
  9. then echo 'i386-ucore-elf-'; \
  10. elif objdump -i 2>&1 | grep 'elf32-i386' >/dev/null 2>&1; \
  11. then echo ''; \
  12. else echo "***" 1>&2; \
  13. echo "*** Error: Couldn't find an i386-ucore-elf version of GCC/binutils." 1>&2; \
  14. echo "*** Is the directory with i386-ucore-elf-gcc in your PATH?" 1>&2; \
  15. echo "*** If your i386-ucore-elf toolchain is installed with a command" 1>&2; \
  16. echo "*** prefix other than 'i386-ucore-elf-', set your GCCPREFIX" 1>&2; \
  17. echo "*** environment variable to that prefix and run 'make' again." 1>&2; \
  18. echo "*** To turn off this error, run 'gmake GCCPREFIX= ...'." 1>&2; \
  19. echo "***" 1>&2; exit 1; fi)
  20. endif
  21. # try to infer the correct QEMU
  22. ifndef QEMU
  23. QEMU := $(shell if which qemu-system-i386 > /dev/null; \
  24. then echo 'qemu-system-i386'; exit; \
  25. elif which i386-ucore-elf-qemu > /dev/null; \
  26. then echo 'i386-ucore-elf-qemu'; exit; \
  27. else \
  28. echo "***" 1>&2; \
  29. echo "*** Error: Couldn't find a working QEMU executable." 1>&2; \
  30. echo "*** Is the directory containing the qemu binary in your PATH" 1>&2; \
  31. echo "***" 1>&2; exit 1; fi)
  32. endif
  33. # eliminate default suffix rules
  34. .SUFFIXES: .c .S .h
  35. # delete target files if there is an error (or make is interrupted)
  36. .DELETE_ON_ERROR:
  37. # define compiler and flags
  38. HOSTCC := gcc
  39. HOSTCFLAGS := -g -Wall -O2
  40. GDB := $(GCCPREFIX)gdb
  41. CC := $(GCCPREFIX)gcc
  42. CFLAGS := -fno-builtin -Wall -ggdb -m32 -gstabs -nostdinc $(DEFS)
  43. CFLAGS += $(shell $(CC) -fno-stack-protector -E -x c /dev/null >/dev/null 2>&1 && echo -fno-stack-protector)
  44. CTYPE := c S
  45. LD := $(GCCPREFIX)ld
  46. LDFLAGS := -m $(shell $(LD) -V | grep elf_i386 2>/dev/null)
  47. LDFLAGS += -nostdlib
  48. OBJCOPY := $(GCCPREFIX)objcopy
  49. OBJDUMP := $(GCCPREFIX)objdump
  50. COPY := cp
  51. MKDIR := mkdir -p
  52. MV := mv
  53. RM := rm -f
  54. AWK := awk
  55. SED := sed
  56. SH := sh
  57. TR := tr
  58. TOUCH := touch -c
  59. OBJDIR := obj
  60. BINDIR := bin
  61. ALLOBJS :=
  62. ALLDEPS :=
  63. TARGETS :=
  64. include tools/function.mk
  65. listf_cc = $(call listf,$(1),$(CTYPE))
  66. # for cc
  67. add_files_cc = $(call add_files,$(1),$(CC),$(CFLAGS) $(3),$(2),$(4))
  68. create_target_cc = $(call create_target,$(1),$(2),$(3),$(CC),$(CFLAGS))
  69. # for hostcc
  70. add_files_host = $(call add_files,$(1),$(HOSTCC),$(HOSTCFLAGS),$(2),$(3))
  71. create_target_host = $(call create_target,$(1),$(2),$(3),$(HOSTCC),$(HOSTCFLAGS))
  72. cgtype = $(patsubst %.$(2),%.$(3),$(1))
  73. objfile = $(call toobj,$(1))
  74. asmfile = $(call cgtype,$(call toobj,$(1)),o,asm)
  75. outfile = $(call cgtype,$(call toobj,$(1)),o,out)
  76. symfile = $(call cgtype,$(call toobj,$(1)),o,sym)
  77. # for match pattern
  78. match = $(shell echo $(2) | $(AWK) '{for(i=1;i<=NF;i++){if(match("$(1)","^"$$(i)"$$")){exit 1;}}}'; echo $$?)
  79. # >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  80. # include kernel/user
  81. INCLUDE += libs/
  82. CFLAGS += $(addprefix -I,$(INCLUDE))
  83. LIBDIR += libs
  84. $(call add_files_cc,$(call listf_cc,$(LIBDIR)),libs,)
  85. # -------------------------------------------------------------------
  86. # kernel
  87. KINCLUDE += kern/debug/ \
  88. kern/driver/ \
  89. kern/trap/ \
  90. kern/mm/ \
  91. kern/libs/ \
  92. kern/sync/ \
  93. kern/fs/
  94. KSRCDIR += kern/init \
  95. kern/libs \
  96. kern/debug \
  97. kern/driver \
  98. kern/trap \
  99. kern/mm \
  100. kern/sync \
  101. kern/fs
  102. KCFLAGS += $(addprefix -I,$(KINCLUDE))
  103. $(call add_files_cc,$(call listf_cc,$(KSRCDIR)),kernel,$(KCFLAGS))
  104. KOBJS = $(call read_packet,kernel libs)
  105. # create kernel target
  106. kernel = $(call totarget,kernel)
  107. $(kernel): tools/kernel.ld
  108. $(kernel): $(KOBJS)
  109. @echo + ld $@
  110. $(V)$(LD) $(LDFLAGS) -T tools/kernel.ld -o $@ $(KOBJS)
  111. @$(OBJDUMP) -S $@ > $(call asmfile,kernel)
  112. @$(OBJDUMP) -t $@ | $(SED) '1,/SYMBOL TABLE/d; s/ .* / /; /^$$/d' > $(call symfile,kernel)
  113. $(call create_target,kernel)
  114. # -------------------------------------------------------------------
  115. # create bootblock
  116. bootfiles = $(call listf_cc,boot)
  117. $(foreach f,$(bootfiles),$(call cc_compile,$(f),$(CC),$(CFLAGS) -Os -nostdinc))
  118. bootblock = $(call totarget,bootblock)
  119. $(bootblock): $(call toobj,boot/bootasm.S) $(call toobj,$(bootfiles)) | $(call totarget,sign)
  120. @echo + ld $@
  121. $(V)$(LD) $(LDFLAGS) -N -T tools/boot.ld $^ -o $(call toobj,bootblock)
  122. @$(OBJDUMP) -S $(call objfile,bootblock) > $(call asmfile,bootblock)
  123. @$(OBJCOPY) -S -O binary $(call objfile,bootblock) $(call outfile,bootblock)
  124. @$(call totarget,sign) $(call outfile,bootblock) $(bootblock)
  125. $(call create_target,bootblock)
  126. # -------------------------------------------------------------------
  127. # create 'sign' tools
  128. $(call add_files_host,tools/sign.c,sign,sign)
  129. $(call create_target_host,sign,sign)
  130. # -------------------------------------------------------------------
  131. # create ucore.img
  132. UCOREIMG := $(call totarget,ucore.img)
  133. $(UCOREIMG): $(kernel) $(bootblock)
  134. $(V)dd if=/dev/zero of=$@ count=10000
  135. $(V)dd if=$(bootblock) of=$@ conv=notrunc
  136. $(V)dd if=$(kernel) of=$@ seek=1 conv=notrunc
  137. $(call create_target,ucore.img)
  138. # -------------------------------------------------------------------
  139. # create swap.img
  140. SWAPIMG := $(call totarget,swap.img)
  141. $(SWAPIMG):
  142. $(V)dd if=/dev/zero of=$@ bs=1M count=128
  143. $(call create_target,swap.img)
  144. # >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  145. $(call finish_all)
  146. IGNORE_ALLDEPS = clean \
  147. dist-clean \
  148. grade \
  149. touch \
  150. print-.+ \
  151. handin
  152. ifeq ($(call match,$(MAKECMDGOALS),$(IGNORE_ALLDEPS)),0)
  153. -include $(ALLDEPS)
  154. endif
  155. # files for grade script
  156. TARGETS: $(TARGETS)
  157. targets: $(TARGETS)
  158. all: $(TARGETS)
  159. .DEFAULT_GOAL := TARGETS
  160. QEMUOPTS = -hda $(UCOREIMG) -drive file=$(SWAPIMG),media=disk,cache=writeback
  161. .PHONY: qemu qemu-nox debug debug-nox
  162. qemu-mon: $(UCOREIMG) $(SWAPIMG)
  163. $(V)$(QEMU) -monitor stdio $(QEMUOPTS) -serial null
  164. qemu: $(UCOREIMG) $(SWAPIMG)
  165. $(V)$(QEMU) -parallel stdio $(QEMUOPTS) -serial null
  166. qemu-nox: $(UCOREIMG) $(SWAPIMG)
  167. $(V)$(QEMU) -serial mon:stdio $(QEMUOPTS) -nographic
  168. TERMINAL := gnome-terminal
  169. gdb: $(UCOREIMG) $(SWAPIMG)
  170. $(V)$(QEMU) -S -s -parallel stdio $(QEMUOPTS) -serial null
  171. debug: $(UCOREIMG) $(SWAPIMG)
  172. $(V)$(QEMU) -S -s -parallel stdio $(QEMUOPTS) -serial null &
  173. $(V)sleep 2
  174. $(V)$(TERMINAL) -e "$(GDB) -q -x tools/gdbinit"
  175. debug-nox: $(UCOREIMG) $(SWAPIMG)
  176. $(V)$(QEMU) -S -s -serial mon:stdio $(QEMUOPTS) -nographic &
  177. $(V)sleep 2
  178. $(V)$(TERMINAL) -e "$(GDB) -q -x tools/gdbinit"
  179. .PHONY: grade touch
  180. GRADE_GDB_IN := .gdb.in
  181. GRADE_QEMU_OUT := .qemu.out
  182. HANDIN := proj$(PROJ)-handin.tar.gz
  183. TOUCH_FILES := kern/trap/trap.c
  184. MAKEOPTS := --quiet --no-print-directory
  185. grade:
  186. $(V)$(MAKE) $(MAKEOPTS) clean
  187. $(V)$(SH) tools/grade.sh
  188. touch:
  189. $(V)$(foreach f,$(TOUCH_FILES),$(TOUCH) $(f))
  190. print-%:
  191. @echo $($(shell echo $(patsubst print-%,%,$@) | $(TR) [a-z] [A-Z]))
  192. .PHONY: clean dist-clean handin packall
  193. clean:
  194. $(V)$(RM) $(GRADE_GDB_IN) $(GRADE_QEMU_OUT)
  195. -$(RM) -r $(OBJDIR) $(BINDIR)
  196. dist-clean: clean
  197. -$(RM) $(HANDIN)
  198. handin: packall
  199. @echo Please visit http://learn.tsinghua.edu.cn and upload $(HANDIN). Thanks!
  200. packall: clean
  201. @$(RM) -f $(HANDIN)
  202. @tar -czf $(HANDIN) `find . -type f -o -type d | grep -v '^\.*$$' | grep -vF '$(HANDIN)'`